"use strict";
var __webpack_require__ = {};
(()=>{
    __webpack_require__.d = (exports1, definition)=>{
        for(var key in definition)if (__webpack_require__.o(definition, key) && !__webpack_require__.o(exports1, key)) Object.defineProperty(exports1, key, {
            enumerable: true,
            get: definition[key]
        });
    };
})();
(()=>{
    __webpack_require__.o = (obj, prop)=>Object.prototype.hasOwnProperty.call(obj, prop);
})();
(()=>{
    __webpack_require__.r = (exports1)=>{
        if ('undefined' != typeof Symbol && Symbol.toStringTag) Object.defineProperty(exports1, Symbol.toStringTag, {
            value: 'Module'
        });
        Object.defineProperty(exports1, '__esModule', {
            value: true
        });
    };
})();
var __webpack_exports__ = {};
__webpack_require__.r(__webpack_exports__);
__webpack_require__.d(__webpack_exports__, {
    WatchInstanceBase: ()=>WatchInstanceBase,
    useWatch: ()=>useWatch
});
const external_react_namespaceObject = require("react");
const external_useForm_js_namespaceObject = require("./useForm.js");
const external_useFormItem_js_namespaceObject = require("./useFormItem.js");
class WatchInstanceBase {
    name;
    form;
    oldValue;
    dispatch;
    callBack;
    updated = ()=>{
        const newValue = this.form.getFieldValue(this.name);
        if (this.oldValue === newValue) return;
        if (this.callBack) this.callBack(newValue, this.form);
        else this.dispatch(newValue);
    };
}
const useWatch = (name, form, callBack)=>{
    const formInstance = form || (0, external_useForm_js_namespaceObject.useFormInstance)();
    const [oldValue, setValue] = (0, external_react_namespaceObject.useState)(formInstance.getFieldValue(name));
    const watch = (0, external_react_namespaceObject.useRef)(new WatchInstanceBase()).current;
    watch.name = name;
    watch.oldValue = oldValue;
    watch.dispatch = setValue;
    watch.callBack = callBack;
    watch.form = formInstance;
    const formItemInstance = (0, external_useFormItem_js_namespaceObject.useFormItem)();
    (0, external_react_namespaceObject.useMemo)(()=>formItemInstance.ctor(name), []);
    formItemInstance.instance = formInstance;
    formItemInstance.isWatch = true;
    formItemInstance.updated = watch.updated;
    (0, external_react_namespaceObject.useEffect)(()=>{
        const unMount = formInstance.registerFormItem(formItemInstance);
        return ()=>unMount();
    }, []);
    return [
        oldValue,
        formInstance,
        watch
    ];
};
exports.WatchInstanceBase = __webpack_exports__.WatchInstanceBase;
exports.useWatch = __webpack_exports__.useWatch;
for(var __webpack_i__ in __webpack_exports__)if (-1 === [
    "WatchInstanceBase",
    "useWatch"
].indexOf(__webpack_i__)) exports[__webpack_i__] = __webpack_exports__[__webpack_i__];
Object.defineProperty(exports, '__esModule', {
    value: true
});
